import { Maybe } from 'maybeasy';
import { Result } from 'resulty';
export declare class NonEmptyList<T> implements Iterable<T> {
    readonly first: T;
    readonly rest: ReadonlyArray<T>;
    constructor(first: T, rest: ReadonlyArray<T>);
    reverse: () => NonEmptyList<T>;
    includes: (value: T) => boolean;
    take: (count: number) => T[];
    drop: (count: number) => T[];
    concat: (values: T[] | NonEmptyList<T>) => NonEmptyList<T>;
    every: (fn: (t: T) => boolean) => boolean;
    some: (fn: (t: T) => boolean) => boolean;
    find: (fn: (t: T) => boolean) => Maybe<T>;
    map: <S>(fn: (t: T) => S) => NonEmptyList<S>;
    and: <S>(fn: (t: T) => S) => NonEmptyList<S>;
    andThen: <S>(fn: (t: T) => NonEmptyList<S>) => NonEmptyList<S>;
    reduce<S>(fn: (accum: S, t: T) => S, start: S): S;
    reduce(fn: (accum: T, t: T) => T): T;
    filter: (fn: (t: T) => boolean) => T[];
    sort: () => NonEmptyList<T>;
    join: (separator?: string) => string;
    toArray: () => T[];
    get length(): number;
    [Symbol.iterator](): Generator<T, void, unknown>;
}
export declare const fromValue: <T>(value: T) => NonEmptyList<T>;
export declare const fromArray: <T>(values: ReadonlyArray<T>) => Result<string, NonEmptyList<T>>;
export declare const fromArrayMaybe: <T>(values: ReadonlyArray<T>) => Maybe<NonEmptyList<T>>;
