"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromArrayMaybe = exports.fromArray = exports.fromValue = exports.NonEmptyList = void 0;
var maybeasy_1 = require("maybeasy");
var resulty_1 = require("resulty");
var Helpers_1 = require("./Helpers");
var NonEmptyList = (function () {
    function NonEmptyList(first, rest) {
        var _this = this;
        this.reverse = function () {
            var reverseRest = _this.rest.slice().reverse();
            var _a = reverseRest.concat([_this.first]), newFirst = _a[0], newRest = _a.slice(1);
            return new NonEmptyList(newFirst, newRest);
        };
        this.includes = function (value) { return _this.first === value || _this.rest.indexOf(value) >= 0; };
        this.take = function (count) { return _this.toArray().slice(0, count); };
        this.drop = function (count) { return _this.toArray().slice(count); };
        this.concat = function (values) {
            return values instanceof NonEmptyList
                ? new NonEmptyList(_this.first, _this.rest.concat(values.toArray()))
                : new NonEmptyList(_this.first, _this.rest.concat(values));
        };
        this.every = function (fn) { return fn(_this.first) && _this.rest.every(fn); };
        this.some = function (fn) { return fn(_this.first) || _this.rest.some(fn); };
        this.find = function (fn) {
            if (fn(_this.first)) {
                return (0, maybeasy_1.just)(_this.first);
            }
            return (0, Helpers_1.find)(fn, _this.rest);
        };
        this.map = function (fn) {
            return new NonEmptyList(fn(_this.first), _this.rest.map(fn));
        };
        this.and = this.map;
        this.andThen = function (fn) {
            var results = _this.map(fn);
            var head = results.first;
            var tail = results.rest;
            var first = head.first;
            var rest = head.rest;
            for (var _i = 0, tail_1 = tail; _i < tail_1.length; _i++) {
                var list = tail_1[_i];
                rest = __spreadArray(__spreadArray(__spreadArray([], rest, true), [list.first], false), list.rest, true);
            }
            return new NonEmptyList(first, rest);
        };
        this.filter = function (fn) { return _this.toArray().filter(fn); };
        this.sort = function () {
            var _a = _this.toArray().sort(), first = _a[0], rest = _a.slice(1);
            return new NonEmptyList(first, rest);
        };
        this.join = function (separator) {
            return _this.toArray().join(separator);
        };
        this.toArray = function () { return __spreadArray([_this.first], _this.rest, true); };
        this.first = first;
        this.rest = rest;
    }
    NonEmptyList.prototype.reduce = function (fn, start) {
        return this.toArray().reduce(fn, start);
    };
    Object.defineProperty(NonEmptyList.prototype, "length", {
        get: function () {
            return this.rest.length + 1;
        },
        enumerable: false,
        configurable: true
    });
    NonEmptyList.prototype[Symbol.iterator] = function () {
        var _i, _a, value;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4, this.first];
                case 1:
                    _b.sent();
                    _i = 0, _a = this.rest;
                    _b.label = 2;
                case 2:
                    if (!(_i < _a.length)) return [3, 5];
                    value = _a[_i];
                    return [4, value];
                case 3:
                    _b.sent();
                    _b.label = 4;
                case 4:
                    _i++;
                    return [3, 2];
                case 5: return [2];
            }
        });
    };
    return NonEmptyList;
}());
exports.NonEmptyList = NonEmptyList;
var fromValue = function (value) { return new NonEmptyList(value, []); };
exports.fromValue = fromValue;
var fromArray = function (values) {
    if (values.length === 0) {
        return (0, resulty_1.err)('Cannot build a non-empty list from an empty array');
    }
    var first = values[0], rest = values.slice(1);
    var list = new NonEmptyList(first, rest);
    return (0, resulty_1.ok)(list);
};
exports.fromArray = fromArray;
var fromArrayMaybe = function (values) {
    return (0, exports.fromArray)(values).cata({
        Err: function () { return (0, maybeasy_1.nothing)(); },
        Ok: function (l) { return (0, maybeasy_1.just)(l); },
    });
};
exports.fromArrayMaybe = fromArrayMaybe;
//# sourceMappingURL=index.js.map